type t_balle =
    { mutable x : float ; mutable angleX : float ;
      mutable y : float ; mutable angleY : float ;
      mutable col : Graphics.color }  

let color_q =
  let q = Queue.create () in
    Queue.push Graphics.green q;
    Queue.push Graphics.blue q;
    Queue.push Graphics.yellow q;
    Queue.push Graphics.cyan q;
    q

let pi = 3.14159265
let radius = 10

let next_color balle =
  Queue.push balle.col color_q;
  balle.col <- (Queue.pop color_q)

let dessine balle =
  Graphics.set_color balle.col;
  Graphics.fill_circle (int_of_float balle.x) (int_of_float balle.y) radius;
  next_color balle

let sine b =
  while true
  do
    b.angleY <- b.angleY +. ( 2. *. pi /. 100. );
    b.y <- b.y +. ( 10. *. (sin b.angleY));
    dessine b;
    Fthread.cooperate ()
  done


let cosine b = 
  while true
  do
    b.angleX <- b.angleX +. ( 2. *. pi /. 100. );
    b.x <- b.x +. ( 10. *. (cos b.angleX));
    dessine b;
    Fthread.cooperate ()
  done

let _ =
  Graphics.open_graph "";
  let sched = Fthread.create_scheduler () in
  let balle = { x = 300.; y = 80.; col = Graphics.red; angleX = 0.; angleY = 0.} in
    ignore (Fthread.create_thread sched sine balle);
    ignore (Fthread.create_thread sched cosine balle);
    Fthread.start_scheduler sched;
    Fthread.exit ()
