type t_balle = {
  mutable x : float ; mutable angleX : float ;
  mutable y : float ; mutable angleY : float ;
  mutable col : Graphics.color
}  

let color_q =
  let q = Queue.create () in
    Queue.push Graphics.green q;
    Queue.push Graphics.blue q;
    Queue.push Graphics.yellow q;
    Queue.push Graphics.cyan q;
    q

let color_l = [Graphics.green; Graphics.blue; Graphics.yellow;
	       Graphics.cyan ; Graphics.red ]
    
let pi = 3.14159265
let radius = 10

(*
let next_color balle =
  Queue.push balle.col color_q;
  balle.col <- (Queue.pop color_q)
*)

let next_color =
  let x = ref 0 in
  let ll = List.length color_l in
    fun balle ->
      balle.col <- List.nth color_l !x;
      x := (!x + 1) mod ll

let dessine balle =
  Graphics.set_color balle.col;
  Graphics.fill_circle (int_of_float balle.x) (int_of_float balle.y) radius;
  next_color balle

let sine b =
  while true
  do
    b.angleY <- b.angleY +. ( 2. *. pi /. 100. );
    b.y <- b.y +. ( 10. *. (sin b.angleY));
    dessine b;
    Thread.yield ()
  done

let cosine b = 
  while true
  do
    b.angleX <- b.angleX +. ( 2. *. pi /. 100. );
    b.x <- b.x +. ( 10. *. (cos b.angleX));
    dessine b;
    Thread.yield ()
  done

let _ =
  Graphics.open_graph "";
  let balle = { x = 300.; y = 80.; col = Graphics.red; 
		angleX = 0.; angleY = 0.} 
  in
  let th = Thread.create sine balle in
    ignore (Thread.create cosine balle);
    Thread.join th
