open Fthread;;

(* petit test simple de la fonction cooperate : *)
(* un thread compteur et deux thread qui se contentent *)
(* d'afficher un texte et de cooperer en boucle... *)


(* creation du scheduler *)
let sched=create_scheduler();;

(* compteur d'instants *)
let x = ref 1;;
(* reference de liste *)
let t = ref [];;

(* thread compteur *)
let rec compteur () =
  (* indique le debut d'un instant *)
  Printf.printf "\n--- Debut instant %d ---\n\n" !x;
  (* affiche les infos du scheduler *)
  (* print_sch sched; *)
  flush stdout;
  (* met la liste a zero *)
  t := [];
  (* coopere *)
  cooperate();
  (* affiche le contenu de la liste *)
  List.iter (fun x -> Printf.printf "%d ;" x) !t;
  Printf.printf "\n"; flush stdout;
  (* le compteur tourne pendant 15 instants *)
  x := !x +1;
  if !x < 15 then
    compteur ()
;;

(* chaque thread question affiche son numero et l'ajoute dans la liste
   durant 10 instants *)
let rec question (x,y)=
  (* affiche le numero du thread *)
  Printf.printf ">>>> thread %d\n" x; 
  flush stdout; 
  (* ajoute le numero dans la liste *)
  t := !t @ [x];
  (* coopere *)
  cooperate();
  (* on fait la meme chose 10 fois *)
  if y < 10 then
    question (x,y+1)
;;

let _ =
  (* creation du compteur d'instants *)
  ignore (create_thread sched compteur ());
  (* creation de 10 thread *)
  for i = 1 to 10 do
    ignore (create_thread sched question (i,0))
  done;
  (* print_sch sched; *)
  (* on attend un peu *)
  for i = 1 to 100000000 do () done;
  (* demarrage du scheduler *)
  start_scheduler sched;
  
  Fthread.exit()
;;


