(* test2.ml : ce test permet de vrifier le comportement des fonctions
   await_n, cooperate_n, et get_value_n *)


open Fthread;;

let sched1= create_scheduler ();;

let event = create_event sched1;;

let x = ref 1;;

let rec compteur _ =
  Printf.printf "\n--- Debut instant %d ---\n\n" !x; flush stdout;
  cooperate();
  x := !x +1;
  if !x < 20 then compteur 0
;;

let rec attente x =
  ( 
    Printf.printf "ATTENTE -> Debut de fonction : attend %d instants\n" x;
    flush stdout;
    await_n event x;
    Printf.printf "ATTENTE -> Fin d'attente\n";
    flush stdout;
    ignore (create_thread sched1 coop 3)
  )

and coop x =
  (
    Printf.printf "COOPERATEUR -> Debut de fonction : coopere %d instants\n" x;
    flush stdout;
    cooperate_n x;
    Printf.printf "COOPERATEUR -> Fin d'attente\n";
    flush stdout;
    ignore (create_thread sched1 attente_val 5)
  )

and attente_val x =
  ( 
    Printf.printf "ATTENTE_VAL -> Debut de fonction : attend %d instants\n" x;
    flush stdout;
    try
      let value = get_value_n event x in
	Printf.printf "ATTENTE_VAL -> Valeur recue : %d\n" value
    with
	_ ->
	  (
	    Printf.printf "ATTENTE_VAL -> Fin d'attente\n";	
	    flush stdout;
	    ignore (create_thread sched1 attente_val 10);
	    ignore (create_thread sched1 envoi_val 3)
	  )
  )

and envoi_val x =
  Printf.printf "EMETEUR -> Debut de fonction\n";
  flush stdout;
  cooperate ();
  cooperate ();
  generate_value event x;
  Printf.printf "EMETEUR -> Valeur %d emise\n" x;
  flush stdout;
;;


let _ =
  ignore (create_thread sched1 compteur 0);
  ignore (create_thread sched1 attente 1);
  start_scheduler sched1;
  exit()
;;
